#include "keys.h"
#include "events.h"
#include "evilwm.h"

#include <X11/Xutil.h>
#include <X11/keysym.h>

#define SHIFT (1 << 24)
#define CTRL (1 << 25)
#define ALT (1 << 26)

#define KEY(K, E, A) K,
int keys_key[] = {
#include "config_key.def"
    -1
};
#undef KEY

#define KEY(K, E, A) E,
void (*keys_ev[]) (EvArgs) = {
#include "config_key.def"
};
#undef KEY

#define KEY(K, E, A) A,
EvArgs keys_args[] = {
#include "config_key.def"
};
#undef KEY

static void keys_run_impl(int k) {
    int index = 0;
    while (1) {
        if (keys_key[index] == -1) return;

        if (keys_key[index] == k) {
            (*keys_ev[index])(keys_args[index]);
        }

        index++;
    }
}

void keys_run(XKeyEvent* e) {
    int k = XKeycodeToKeysym(dpy, e->keycode, 0);
    if (e->state & ShiftMask) k |= SHIFT;
    keys_run_impl(k);
}

void keys_run_button(XButtonEvent* be) {
    int k;
    if (be->button == Button1) k = XK_Pointer_Button1;
    else if (be->button == Button2) k = XK_Pointer_Button2;
    else if (be->button == Button3) k = XK_Pointer_Button3;
    else if (be->button == Button4) k = XK_Pointer_Button4;
    else if (be->button == Button5) k = XK_Pointer_Button5;
    if (be->state & ShiftMask) k |= SHIFT;
    if (be->state & ControlMask) k |= CTRL;
    if (be->state & Mod1Mask) k |= ALT;
    keys_run_impl(k);
}

